'''
The file-buffer for data transfer
'''

from os import path, remove

class Buffer(object):
    def __init__(self, path, name='buffer'):
        self.filename = path + name
        self.file = None

    def check(self):
        try:
            return path.isfile(self.filename)
        except:
            return False
       
    def write(self, text=''):
        try:
            self.file = open(self.filename, 'a')
            self.file.write(text.encode('utf-8'))
            self.file.close()
            self.file = None
        except:
            return False
        return True    

    def read(self, clear=True):
        try:
            try:
                self.file = open(self.filename, 'r')
                try:
                    return self.file.read().decode('utf-8')
                finally:
                    self.file.close()
                    self.file = None
            finally:
                if clear:
                    self.clear()    
        except:
            return ''
    
    def clear(self):
        try:
            remove(self.filename)
        except:
            return False
        return True